--MiniMap Standard .lua

local function AddMiniMapIcon(inst, img, priority)
	if inst and not inst.MiniMapEntity then
		local minimap = inst.entity:AddMiniMapEntity()
		minimap:SetIcon( img )					-- png name found in data/minimap/minimap_data.tex
		minimap:SetPriority( priority or 1 )	-- 1-10
		--minimap:SetRenderOnTopOfMask( false )	-- true/false
	end
end

--Plants
local function wheatPrefabPostInit(inst)
	if inst then AddMiniMapIcon(inst, "wheat.png", 5) end
end

local function mushroom_treePrefabPostInit(inst)
	if inst then AddMiniMapIcon(inst, "mushroom_tree.png", 5) end
end
--/Plants

--Animals
local function cactusPrefabPostInit(inst)
	if inst then AddMiniMapIcon(inst, "cactus.png", 5) end
end
--/Animals

--Monsters
local function cavespider_denPrefabPostInit(inst)
	if inst then AddMiniMapIcon(inst, "cavespider_den.png", 5) end
end
--/Monsters

--Graves
local function farm1PrefabPostInit(inst)
	if inst then AddMiniMapIcon(inst, "farm1.png", 5) end
end
--/Graves

--Teleportato items
local function teleportatoPrefabPostInit(inst)
	if inst then AddMiniMapIcon(inst, "teleportato.png", 5) end
end
--/Teleportato items

--Plants
AddPrefabPostInit( "carrot_planted", wheatPrefabPostInit )
AddPrefabPostInit( "mandrake", wheatPrefabPostInit )
AddPrefabPostInit( "blue_mushroom", mushroom_treePrefabPostInit )
AddPrefabPostInit( "green_mushroom", mushroom_treePrefabPostInit )
AddPrefabPostInit( "red_mushroom", mushroom_treePrefabPostInit )
AddPrefabPostInit( "marsh_bush", marsh_bushPrefabPostInit )
--/Plants

--Animals

AddPrefabPostInit( "beefaloherd", cactusPrefabPostInit )
AddPrefabPostInit( "koalefant_summer", cactusPrefabPostInit )
AddPrefabPostInit( "koalefant_winter", cactusPrefabPostInit )
--AddPrefabPostInit( "rabbithole", cactusPrefabPostInit )
--/Animals

--Monsters
AddPrefabPostInit( "spiderqueen", cavespider_denPrefabPostInit )
AddPrefabPostInit( "batcave", batcavePrefabPostInit )
--/Monsters

--Other
AddPrefabPostInit( "chester_eyebone", cactusPrefabPostInit )
--AddPrefabPostInit( "obelisk", srockPrefabPostInit )
--AddPrefabPostInit( "obelisk", srockPrefabPostInit )
--AddPrefabPostInit( "pigtorch", cactusPrefabPostInit )
--/Other

--Graves
AddPrefabPostInit( "mound", farm1PrefabPostInit )
--/Graves

--Teleportato items
--AddPrefabPostInit( "teleportato_ring", teleportatoPrefabPostInit )
--AddPrefabPostInit( "teleportato_box", teleportatoPrefabPostInit )
--AddPrefabPostInit( "teleportato_crank", teleportatoPrefabPostInit )
--AddPrefabPostInit( "teleportato_potato", teleportatoPrefabPostInit )
--/Teleportato items