local assets=
{
	Asset("ANIM", "anim/bombs.zip"),
	Asset("ANIM", "anim/explode.zip"),
	Asset("ATLAS", "images/inventoryimages/bombs.xml")
}

local prefabs =
{
    "explode_small"
}

local function OnExplodeFn(inst)
    local pos = Vector3(inst.Transform:GetWorldPosition())
    inst.SoundEmitter:KillSound("hiss")
    inst.SoundEmitter:PlaySound("dontstarve/common/blackpowder_explo")

    local explode = SpawnPrefab("explode_small")
    local pos = inst:GetPosition()
    explode.Transform:SetPosition(pos.x, pos.y, pos.z)

    --local explode = PlayFX(pos,"explode", "explode", "small")
    explode.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )
    explode.AnimState:SetLightOverride(1)
end

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()		
    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("heat_rock")
    inst.AnimState:SetBuild("bombs")
    inst.AnimState:PlayAnimation(5)
    inst.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )
    
    inst:AddComponent("inspectable")

    inst:AddComponent("stackable")
	inst.components.stackable.maxsize = 40

MakeSmallBurnable(inst, 0.1)
--    MakeSmallPropagator(inst)

    inst:AddComponent("explosive")
    inst.components.explosive:SetOnExplodeFn(OnExplodeFn)
--    inst.components.explosive:SetOnIgniteFn(OnIgniteFn)
    inst.components.explosive.explosivedamage = (TUNING.GUNPOWDER_DAMAGE * 1.5)
    
    inst:AddComponent("inventoryitem")
  	 inst.components.inventoryitem.atlasname = "images/inventoryimages/bombs.xml"
	
	inst:AddComponent("singledroppable")

-- inst:AddComponent("burnable")

	--
	  inst:ListenForEvent("ondropped", function(inst)
	  
	  inst.SoundEmitter:PlaySound("dontstarve/common/blackpowder_fuse_LP", "hiss")
--	  inst.components.burnable.burning = true
--	  inst:AddTag("fire")
--	  inst:PushEvent("onignite")
--	  inst.components.explosive:OnIgnite()
	  
          ------------------------------
          inst:DoTaskInTime(0.8, function(inst)
--            print "Animation state 3"
                inst.AnimState:PlayAnimation(3)
	         end, inst)
          ------------------------------
          inst:DoTaskInTime(1.6, function(inst)
--            print "Animation state 5"
                inst.AnimState:PlayAnimation(5)
	         end, inst)
          ------------------------------
          inst:DoTaskInTime(2.4, function(inst)
--            print "Animation state 3"
                inst.AnimState:PlayAnimation(3)
	         end, inst)
          ------------------------------
          inst:DoTaskInTime(3.2, function(inst)
--            print "Animation state 5"
                inst.AnimState:PlayAnimation(5)
	         end, inst)
          ------------------------------
          inst:DoTaskInTime(3.5, function(inst)
--            print "Animation state 3"
                inst.AnimState:PlayAnimation(3)
	         end, inst)
          ------------------------------
          inst:DoTaskInTime(3.8, function(inst)
--            print "Animation state 5"
                inst.AnimState:PlayAnimation(5)
	         end, inst)
          ------------------------------
          inst:DoTaskInTime(4.1, function(inst)
--            print "Animation state 3"
                inst.AnimState:PlayAnimation(3)
	         end, inst)
          
          ------------------------------
          inst:DoTaskInTime(4.2, function(inst)
--            print "Animation state 4"
                inst.AnimState:PlayAnimation(4)
	         end, inst)
          ------------------------------
          inst:DoTaskInTime(4.3, function(inst)
--            print "Animation state 2"
                inst.AnimState:PlayAnimation(2)
	         end, inst)
          ------------------------------
          inst:DoTaskInTime(4.4, function(inst)
--            print "Animation state 4"
                inst.AnimState:PlayAnimation(4)
	         end, inst)
          ------------------------------
          inst:DoTaskInTime(4.5, function(inst)
--            print "Animation state 2"
                inst.AnimState:PlayAnimation(2)
	         end, inst)
          ------------------------------
          inst:DoTaskInTime(4.6, function(inst)
--            print "Animation state 4"
                inst.AnimState:PlayAnimation(4)
	         end, inst)
          ------------------------------
          inst:DoTaskInTime(4.7, function(inst)
--            print "Animation state 2"
                inst.AnimState:PlayAnimation(2)
	         end, inst)
          ------------------------------
          inst:DoTaskInTime(4.8, function(inst)
--            print "Animation state 4"
                inst.AnimState:PlayAnimation(4)
	         end, inst)
          ------------------------------
          inst:DoTaskInTime(4.9, function(inst)
--            print "Animation state 2"
                inst.AnimState:PlayAnimation(2)
	         end, inst)
	         
          ------------------------------
          inst:DoTaskInTime(5, function(inst)
--          print "Animation state 1"
                inst.AnimState:PlayAnimation(1)
--            print "I am lighter!"
--                inst:AddComponent("lighter")
        if not inst.components.burnable:IsBurning() then
                inst.components.burnable:Ignite()
        end
--                inst.components.explosive:OnIgnite()
--            inst.components.explosive:OnExplodeFn(inst)
---------------------------------------------------------------------------
--    local pos = Vector3(inst.Transform:GetWorldPosition())
--    inst.SoundEmitter:KillSound("hiss")
--    inst.SoundEmitter:PlaySound("dontstarve/common/blackpowder_explo")

--    local explode = SpawnPrefab("explode_small")
--    local pos = inst:GetPosition()
--    explode.Transform:SetPosition(pos.x, pos.y, pos.z)

    --local explode = PlayFX(pos,"explode", "explode", "small")
--    explode.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )
--    explode.AnimState:SetLightOverride(1)
    
--    inst.PushEvent("explosion", {explosive = inst.bombs})
--    inst:remove
---------------------------------------------------------------------------
	         end, inst)
          ------------------------------
--          inst:DoTaskInTime(5.1, function(inst)
--            print "no more lighter"
--                inst:RemoveComponent("lighter")
--	         end, inst)
end)
 --
 	
	return inst
end

return Prefab( "common/inventory/bombs", fn, assets, prefabs) 
