local assets=
{
	Asset("ANIM", "anim/tunic_red.zip"),
  Asset("ATLAS", "images/inventoryimages/tunic_red.xml")
}


local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_body", "tunic_red", "swap_body")
    owner.components.health.fire_damage_scale = 0
    owner:AddTag("wearingredtunic")
end

local function onunequip(inst, owner) 
    owner.AnimState:ClearOverrideSymbol("swap_body")
    owner:RemoveTag("wearingredtunic")
  if not owner:HasTag("dinsfire") then
         owner.components.health.fire_damage_scale = 1
  end
    
end

local function fn(Sim)
	local inst = CreateEntity()
    
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("armor_grass")
    inst.AnimState:SetBuild("tunic_red")
    inst.AnimState:PlayAnimation("anim")
    
    inst:AddComponent("inspectable")
    
    inst:AddTag("irreplaceable")
    
    inst:AddComponent("inventoryitem")
  	 inst.components.inventoryitem.atlasname = "images/inventoryimages/tunic_red.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.BODY
    
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
    
    return inst
end


return Prefab( "common/inventory/tunic_red", fn, assets ) 
