require "prefabutil"

local assets=
{
    Asset("ANIM", "anim/maxwells_chest.zip"),


    Asset("IMAGE", "images/ui_chest_5x16.tex"),
    Asset("ATLAS", "images/ui_chest_5x16.xml"),
    Asset("IMAGE", "images/maxwellschest.tex"),
    Asset("ATLAS", "images/maxwellschest.xml"),
}

local chests = {
	maxwells_chest = {
		bank="chest",
		build="maxwells_chest",
	},
	}


local function onopen(inst) 
	inst.AnimState:PlayAnimation("open") 
	inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_open")
end 

local function onclose(inst) 
	inst.AnimState:PlayAnimation("close") 
	inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_close")		
end 

local function onhammered(inst, worker)
	inst.components.lootdropper:DropLoot()
	inst.components.container:DropEverything()
	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")	
	inst:Remove()
end

local function onhit(inst, worker)
	inst.AnimState:PlayAnimation("hit")
	inst.components.container:DropEverything()
	inst.AnimState:PushAnimation("closed", false)
	inst.components.container:Close()
end

local function onbuilt(inst)
	inst.AnimState:PlayAnimation("place")
	inst.AnimState:PushAnimation("closed", false)
end

		local slotpos = {}
		for y = 4, 0, -1 do
			for x = 0, 15 do
				table.insert(slotpos, Vector3(80*x-346*2+90, 80*y-100*2+40,0)) -- x = left to right
			end
		end
local INTENSITY = .9
local function chest(style)

	local fn = function(Sim)
	
		local inst = CreateEntity()
		inst.entity:AddTransform()
		inst.entity:AddAnimState()
		inst.entity:AddSoundEmitter()
		local minimap = inst.entity:AddMiniMapEntity()
		minimap:SetIcon( "treasure_chest.png" )
		inst:AddTag("structure")
		inst.AnimState:SetBank(chests[style].bank)
		inst.AnimState:SetBuild(chests[style].build)
		inst.AnimState:PlayAnimation("closed")
		
		inst:AddComponent("inspectable")
		inst:AddComponent("container")
		
		inst.components.container.onopenfn = onopen
		inst.components.container.onclosefn = onclose
-----
-- old line
        --inst.components.container.widgetbgimage = "mods/MaxwellsChest/images/ui_chest_5x16.tex"
-- new lines
        inst.components.container.widgetbgimage = "ui_chest_5x16.tex"
        inst.components.container.widgetbgatlas = "images/ui_chest_5x16.xml"

----		
		inst.components.container.widgetpos = Vector3(150,250,0)
		inst.components.container.widgetbgimagetint = {r=.87,g=.73,b=.66,a=1}
		inst.components.container.numslots = #slotpos
		inst.components.container.widgetslotpos = slotpos

		inst:AddComponent("lootdropper")
		inst:AddComponent("workable")
		inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
		inst.components.workable:SetWorkLeft(2)
		inst.components.workable:SetOnFinishCallback(onhammered)
		inst.components.workable:SetOnWorkCallback(onhit) 
		
		inst:ListenForEvent( "onbuilt", onbuilt)
		MakeSnowCovered(inst, .01)	
------
    local light = inst.entity:AddLight()
    light:SetIntensity(INTENSITY)
    light:SetRadius(2)
    light:SetColour(255/255, 255/255, 1/255)
    light:Enable(true)
------
		return inst
	end
	return fn

	end

return	Prefab( "common/prefab/maxwellschest", chest("maxwells_chest"), assets),
		MakePlacer("common/prefab/maxwellschest_placer", "chest", "maxwells_chest", "closed")
