local assets=
{
	Asset("ANIM", "anim/silkworm.zip"),
        Asset("ATLAS", "images/inventoryimages/silkworm.xml"),
        Asset("ATLAS", "images/inventoryimages/silkworm_cooked.xml")
        
       
}




local prefabs =
{
         "cookedmeat",
         "silkworm_cooked",
         "spoiled_food",	
         
         
}    

local function common(inst)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    
    MakeInventoryPhysics(inst)
    
    
	
    inst:AddComponent("edible")
    inst.components.edible.ismeat = true    
    inst.components.edible.foodtype = "MEAT"
    
    inst:AddComponent("stackable")
    inst:AddComponent("bait")
    
    inst:AddComponent("inspectable")
    
    
    
    inst:AddComponent("tradable")
    inst.components.tradable.goldvalue = TUNING.GOLD_VALUES.MEAT

	inst:AddComponent("perishable")
	inst.components.perishable:SetPerishTime(TUNING.PERISH_FAST)
	inst.components.perishable:StartPerishing()
	inst.components.perishable.onperishreplacement = "spoiled_food"

    return inst
end


local function raw(Sim)
	local inst = common()
    inst.AnimState:SetBank("meat")
    inst.AnimState:SetBuild("silkworm")
    inst.AnimState:PlayAnimation("raw")
    
    inst.components.edible.healthvalue = TUNING.HEALING_TINY
    
    inst.components.edible.hungervalue = TUNING.CALORIES_MED
    inst.components.edible.sanityvalue = -TUNING.SANITY_SMALL
    
    inst.components.perishable:SetPerishTime(TUNING.PERISH_FAST)
    
    inst:AddComponent("cookable")
    inst.components.cookable.product = "silkworm_cooked"
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/silkworm.xml"
    return inst
    end


local function cooked(Sim)
	local inst = common()
    inst.AnimState:SetBank("meat")
    inst.AnimState:SetBuild("silkworm_cooked")
    inst.AnimState:PlayAnimation("cooked")
    inst.components.edible.healthvalue = TUNING.HEALING_SMALL
    inst.components.edible.hungervalue = TUNING.CALORIES_MED
    inst.components.edible.sanityvalue = 0
    inst.components.perishable:SetPerishTime(TUNING.PERISH_MED)
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/silkworm_cooked.xml"  
    return inst
end

return Prefab( "common/inventory/silkworm", raw, assets, prefabs),
       Prefab( "common/inventory/silkworm_cooked", cooked, assets)