
function MakeHat(name)

    local fname = "hat_"..name
    local symname = name
    local prefabname = symname
    local assets=
    {
	Asset("ANIM", "anim/kakaxi.zip"),

        Asset("IMAGE", "images/inventoryimages/kakaxi.tex"),
         Asset("ATLAS", "images/inventoryimages/kakaxi.xml"),

	Asset("ANIM", "anim/humu.zip"),

         Asset("IMAGE", "images/inventoryimages/humu.tex"),
         Asset("ATLAS", "images/inventoryimages/humu.xml"),

	Asset("ANIM", "anim/hue.zip"),

         Asset("IMAGE", "images/inventoryimages/hue.tex"),
         Asset("ATLAS", "images/inventoryimages/hue.xml"),
    }

    local function onequip(inst, owner)
        owner.AnimState:OverrideSymbol("swap_hat", fname, "swap_hat")
        owner.AnimState:Show("HAT")
        owner.AnimState:Show("HAT_HAIR")
        owner.AnimState:Hide("HAIR_NOHAT")
        owner.AnimState:Hide("HAIR")
        
               if owner:HasTag("player") then
			owner.AnimState:Hide("HEAD")
			owner.AnimState:Show("HEAD_HAIR")
		end

    end

    local function onunequip(inst, owner)
        owner.AnimState:Hide("HAT")
        owner.AnimState:Hide("HAT_HAIR")
        owner.AnimState:Show("HAIR_NOHAT")
        owner.AnimState:Show("HAIR")

		if owner:HasTag("player") then
	        owner.AnimState:Show("HEAD")
			owner.AnimState:Hide("HEAD_HAIR")
		end
        inst.components.useableitem:StopUsingItem()
    end
    ---------------------------------------------------  
local function canuseitem(inst)
return inst.components.equippable:IsEquipped()
end  
local function onfinished(inst)
    inst:Remove()
end
local function SpawnEffect(inst)
    local pt = inst:GetPosition()
    local fx = SpawnPrefab("small_puff")
    fx.Transform:SetPosition(pt.x, pt.y, pt.z)
    fx.Transform:SetScale(0.5,0.5,0.5)
end
    ---------------------------------------------------  
local function onlight(inst)
    if inst.components.equippable:IsEquipped()and not GetClock():IsDay() then
        inst.Light:Enable(true)
    else
        inst.Light:Enable(false)
    end
end

local function GetTelePoint(pt)

    local theta = math.random() * 2 * PI
    local radius = 30

	local offset = FindWalkableOffset(pt, theta, radius, 12, true)
	if offset then
		return pt+offset
	end
end

local function onusekakaxi(inst)
        local owner = inst.components.inventoryitem.owner or nil
    if owner then
        local pos = Vector3(owner.Transform:GetWorldPosition())
        local ents = TheSim:FindEntities(pos.x, pos.y, pos.z, 50)
        for i,ent in ipairs(ents) do
            if ent.components.combat and ent.components.combat.target == owner then
            ent.components.combat:SetTarget(nil)
            end
         end
            owner.sg:GoToState("hide")
		    owner.components.health:SetInvincible(true)
          SpawnEffect(owner)
          local log = SpawnPrefab("log")
          local pt = Vector3(owner.Transform:GetWorldPosition()) + Vector3(0,4,0) 
          if log then
            log.Transform:SetPosition(pt:Get())
           end

    owner:DoTaskInTime(1.2, function()
    local pt = Vector3(owner.Transform:GetWorldPosition())
    local tele_pt = GetTelePoint(pt)
    if tele_pt then owner.Physics:Teleport(tele_pt:Get()) end
    owner.sg:GoToState("idle")
    owner.components.health:SetInvincible(false)
     end)

    inst.components.finiteuses:Use(1)
    end
end
    ---------------------------------------------------
    local function onusehumu(inst)
         if inst.components.equippable.walkspeedmult == 1 then
         inst.components.equippable.walkspeedmult = 7
         inst:DoTaskInTime(5, function() inst.components.equippable.walkspeedmult = 1 end)
         else
         inst.components.equippable.walkspeedmult = 1
        end
    inst.components.finiteuses:Use(1)
    end

    local function onusehue(inst)
        local owner = inst.components.inventoryitem.owner
        if owner then
	local health_percent = owner.components.health:GetPercent()
	owner.components.health:SetPercent(0.5*health_percent)
	local armor_percent = inst.components.armor:GetPercent()
	inst.components.armor:SetPercent(0.5*armor_percent)
            local pos = Vector3(owner.Transform:GetWorldPosition())
            local ents = TheSim:FindEntities(pos.x, pos.y, pos.z, 20)
            for i,ent in ipairs(ents) do
            if ent.components.health and ent.components.combat and (ent.components.combat.target ==owner or owner.components.combat.target == ent or ent:HasTag("monster")) then
            ent:Remove()
            end
            end
        --if armor_percent <= 0.05 then inst:Remove() end
        end
    end

    ---------------------------------------------------

    local function simple()
        local inst = CreateEntity()

        inst.entity:AddTransform()
        inst.entity:AddAnimState()
        MakeInventoryPhysics(inst)

        inst.AnimState:SetBank("beehat")
        inst.AnimState:SetBuild(fname)
        inst.AnimState:PlayAnimation("anim")

        inst:AddTag("hat")

        inst:AddComponent("inspectable")

        inst:AddComponent("inventoryitem")
        inst.components.inventoryitem.atlasname = "images/inventoryimages/"..name..".xml"
        inst:AddComponent("tradable")

        inst:AddComponent("equippable")
        inst.components.equippable.equipslot = EQUIPSLOTS.HEAD

        inst.components.equippable:SetOnEquip( onequip )

        inst.components.equippable:SetOnUnequip( onunequip )

        return inst
    end

    local function kakaxi()
        local inst = simple()
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(10)
    inst.components.finiteuses:SetUses(10)
    inst.components.finiteuses:SetOnFinished( onfinished)
        inst:AddComponent("useableitem")
        inst.components.useableitem:SetOnUseFn(onusekakaxi)
    inst.components.useableitem:SetCanInteractFn(canuseitem)
		return inst
    end

    local function humu()
        local inst = simple()
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(4)
    inst.components.finiteuses:SetUses(4)
    inst.components.finiteuses:SetOnFinished( onfinished)
    inst.components.equippable.walkspeedmult = 1
        inst:AddComponent("useableitem")
        inst.components.useableitem:SetOnUseFn(onusehumu)
        local light = inst.entity:AddLight()
        light:SetFalloff(0.5)
        light:SetIntensity(.8)
        light:SetRadius(1)
        light:SetColour(149/255, 49/255, 208/255)
        inst:DoPeriodicTask(0.5, function() onlight(inst) end)
		return inst
    end

    local function hue()
        local inst = simple()
		inst:AddComponent("armor")
		inst.components.armor:InitCondition(1000, 0.8)
        inst:AddComponent("useableitem")
        inst.components.useableitem:SetOnUseFn(onusehue)
		return inst
    end
   
    ---------------------------------------------------
    
    local fn = nil
    local prefabs = nil
    if name == "kakaxi" then
        fn = kakaxi
    elseif name == "humu" then
		fn = humu
    elseif name == "hue" then
		fn = hue

    end

    return Prefab( "common/inventory/"..prefabname, fn or simple, assets, prefabs)
end

return MakeHat("kakaxi"),
        MakeHat("humu"),

        MakeHat("hue")
