
-- In a prefab file, you need to list all the assets it requires.
-- These can be either standard assets, or custom ones in your mod
-- folder.
local Assets =
{
	Asset("ANIM", "anim/emptyhg.zip"), -- a standard asset
    Asset("ATLAS", "inventoryimages/emptyhg.xml"),    -- a custom asset, found in the mod folder
}

-- Write a local function that creats, customizes, and returns an instance of the prefab.
local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("moditem")
    inst.AnimState:SetBuild("emptyhg")
    inst.AnimState:PlayAnimation("idle")
    
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "inventoryimages/emptyhg.xml"

	inst:AddComponent("inspectable")
    
    return inst
end

-- Add some strings for this item
STRINGS.NAMES.EMPTYHG = "Empty Handgun"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.EMPTYHG = "Needs to be reload."


-- Finally, return a new prefab with the construction function and assets.
return Prefab( "common/inventory/emptyhg", fn, Assets)

