local assets=
{
	
	Asset("ANIM", "anim/leekbaton.zip"),
	Asset("ANIM", "anim/swap_leekbaton.zip"),
    
    Asset("ATLAS", "inventoryimages/leekbaton.xml"),
}

local function onfinished(inst)
    inst:Remove()
end

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_leekbaton", "swap_nightmaresword")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
	local com = owner.components.combat
	inst.ownerAreaHitRange = com.areahitrange
	inst.ownerAreaHitDamagePercent = com.areahitdamagepercent
	com.areahitrange = 3
	com.areahitdamagepercent = 0.3 
	local light = inst.entity:AddLight()
    inst.Light:Enable(true)
	inst.Light:SetRadius(5)
    inst.Light:SetFalloff(1)
    inst.Light:SetIntensity(.7)
    inst.Light:SetColour(124/255,252/255,0/255)
end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
	local com = owner.components.combat
	com.areahitrange = inst.ownerAreaHitRange
	com.areahitdamagepercent = inst.ownerAreaHitDamagePercent
	inst.Light:Enable(false)
end


local function onattack(inst, owner, target)
    if owner.components.hunger and owner.components.hunger:GetPercent() < 1 and not target:HasTag("wall") then
        owner.components.hunger:DoDelta(-1)
    end
	
	
	
end

local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
	
    
    inst.AnimState:SetBank("nightmaresword")
    inst.AnimState:SetBuild("leekbaton")
    inst.AnimState:PlayAnimation("idle")
    inst.AnimState:SetMultColour(1, 1, 1, 0.6)
    
    inst:AddTag("shadow")
    inst:AddTag("sharp")
	
    
	
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(25)
	inst.components.weapon:SetOnAttack(onattack)
	
  
	


	
    -------
    
    

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "inventoryimages/leekbaton.xml"
    
    
    inst:AddComponent("equippable")
	inst.components.equippable.walkspeedmult = 1.2,
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
	
	local light = inst.entity:AddLight()
    inst.Light:Enable(true)
	inst.Light:SetRadius(5)
    inst.Light:SetFalloff(1)
    inst.Light:SetIntensity(.7)
    inst.Light:SetColour(124/255,252/255,0/255)
    
	
    return inst
end

STRINGS.NAMES.LEEKBATON = "Leek Baton"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.LEEKBATON = "Nation's peace-keeping instrument, with style!"

return Prefab( "common/inventory/leekbaton", fn, assets) 
