local assets=
{
	Asset("ANIM", "anim/mikuhgs.zip"),
	Asset("ANIM", "anim/swap_mikuhgs.zip"),
    Asset("ATLAS", "inventoryimages/mikuhgs.xml"),
}

    
local prefabs = 
{
    "ice_projectile",
}



local function onfinished(inst)
	local owner = inst.components.inventoryitem and inst.components.inventoryitem.owner
    inst:Remove()
	if owner and owner.components.inventory then
            local strawhat = SpawnPrefab("emptyhg")
            owner.components.inventory:GiveItem(strawhat)
        end
end

local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_object", "swap_mikuhgs", "swap_boomerang")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

local function onattack(inst, attacker, target)
	inst:AddComponent("locomotor")
	target.components.locomotor.walkspeed = 1
	target.components.locomotor.runspeed = 1
	
    
end


local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    
    anim:SetBank("boomerang")
    anim:SetBuild("mikuhgs")
    anim:PlayAnimation("idle")
    
    inst:AddTag("icestaff")
    
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(100)
    inst.components.weapon:SetRange(12, 20)
    inst.components.weapon:SetOnAttack(onattack)
    inst.components.weapon:SetProjectile("bullet")
    
    -------
    
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(12)
    inst.components.finiteuses:SetUses(12)
    
    inst.components.finiteuses:SetOnFinished( onfinished )

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "inventoryimages/mikuhgs.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
	
    return inst
end

STRINGS.NAMES.MIKUHGS = "Miku Handgun w/ Slow Ammo"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.MIKUHGS = "Secret Police Handgun with Secret Slow Properties."

return Prefab( "common/inventory/mikuhgs", fn, assets) 
