
-- In a prefab file, you need to list all the assets it requires.
-- These can be either standard assets, or custom ones in your mod
-- folder.
local Assets =
{
	Asset("ANIM", "anim/rhammo.zip"), -- a standard asset
    Asset("ATLAS", "inventoryimages/rhammo.xml"),    -- a custom asset, found in the mod folder
}

-- Write a local function that creats, customizes, and returns an instance of the prefab.
local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("moditem")
    inst.AnimState:SetBuild("rhammo")
    inst.AnimState:PlayAnimation("idle")
	inst:AddComponent("guns")
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "inventoryimages/rhammo.xml"
	inst:AddComponent("stackable")
	inst:AddComponent("inspectable")
    

    return inst
end

-- Add some strings for this item
STRINGS.NAMES.RHAMMO = "Handgun Ammo"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.RHAMMO = "A box of 9mm rounds."


-- Finally, return a new prefab with the construction function and assets.
return Prefab( "common/inventory/rhammo", fn, Assets)

