
-- In a prefab file, you need to list all the assets it requires.
-- These can be either standard assets, or custom ones in your mod
-- folder.
local Assets =
{
	Asset("ANIM", "anim/srhammo.zip"), -- a standard asset
    Asset("ATLAS", "inventoryimages/srhammo.xml"),    -- a custom asset, found in the mod folder
}

-- Write a local function that creats, customizes, and returns an instance of the prefab.
local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("moditem")
    inst.AnimState:SetBuild("srhammo")
    inst.AnimState:PlayAnimation("idle")
	inst:AddComponent("guns1")
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "inventoryimages/srhammo.xml"
	inst:AddComponent("stackable")
	inst:AddComponent("inspectable")
    

    return inst
end

-- Add some strings for this item
STRINGS.NAMES.SRHAMMO = "Slow Handgun Ammo"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SRHAMMO = "A box of 9mm rounds with Slow properties."


-- Finally, return a new prefab with the construction function and assets.
return Prefab( "common/inventory/srhammo", fn, Assets)

