require "prefabutil"

local assets=
{
	Asset("ANIM", "anim/gyn.zip"),
	--Asset("ANIM", "anim/ui_chest_3x3.zip"),
	Asset("IMAGE", "images/inventoryimages/gyn.tex"),
        Asset("ATLAS", "images/inventoryimages/gyn.xml"),
}




local function onopen(inst) 
	inst.AnimState:PlayAnimation("open") 
	inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_open")		
end 

local function onclose(inst) 
	inst.AnimState:PlayAnimation("close") 
	inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_close")		
end 



local function onhammered(inst, worker)
	inst.components.lootdropper:DropLoot()
	inst.components.container:DropEverything()
	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_metal")
	
	inst:Remove()
end

	
 

local function onhit(inst, worker)
	inst.AnimState:PlayAnimation("hit")
	inst.components.container:DropEverything()
	inst.AnimState:PushAnimation("closed", false)
	inst.components.container:Close()
end

local function onbuilt(inst)
	inst.AnimState:PlayAnimation("place")
	inst.AnimState:PushAnimation("closed", false)
end

local slotpos = {}

for y = 6, -2, -1 do
	for x = -3, 5 do
		table.insert(slotpos, Vector3(80*x-80*2+80, 80*y-80*2+80,0))
	end
end

local function itemtest(inst, item, slot)
	return (item.components.edible and item.components.perishable) or item.prefab == "spoiled_food"
end

		
local function fn(Sim)
	local inst = CreateEntity()
	
	inst:AddTag("fridge")
    inst:AddTag("structure")
	
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    
	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon( "icebox.png" )

	inst.entity:AddLight()
    inst.Light:Enable(true)
    inst.Light:SetIntensity(0.75)
    inst.Light:SetColour(241/255,141/255,0/255)
    inst.Light:SetFalloff( 0.4 )
    inst.Light:SetRadius( 8 ) 

	


    inst.AnimState:SetBank("icebox")
    inst.AnimState:SetBuild("gyn")
    inst.AnimState:PlayAnimation("closed")
    
    inst:AddComponent("inspectable")
    inst:AddComponent("container")
    inst.components.container.itemtestfn = itemtest
    inst.components.container:SetNumSlots(#slotpos)
    
    inst.components.container.onopenfn = onopen
    inst.components.container.onclosefn = onclose
    
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_chest_9x9"
    inst.components.container.widgetanimbuild = "ui_chest_9x9"
    inst.components.container.widgetpos = Vector3(0,200,0)
    
    inst:AddComponent("lootdropper")
    inst:AddComponent("workable")

    inst.Transform:SetScale(1.5, 2, 2)
	
    inst:ListenForEvent( "onbuilt", onbuilt)
	MakeSnowCovered(inst, .01)	
    return inst
end

return Prefab( "common/gyn", fn, assets),
		MakePlacer("common/icebox_placer", "icebox", "gyn", "closed") 

