local assets=
{
	Asset("ANIM", "anim/xuezou.zip"),
	Asset("ANIM", "anim/swap_xuezou.zip"),
        Asset("IMAGE", "images/inventoryimages/xuezou.tex"),
        Asset("ATLAS", "images/inventoryimages/xuezou.xml"),
}

local function onfinished(inst)
    inst:Remove()
end

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_xuezou", "swap_nightmaresword")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
end

local function onunequip(inst, owner)
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
end

local function onattack(inst, attacker, target)
    if attacker and attacker.components.sanity then
        attacker.components.sanity:DoDelta(-3)

        attacker.components.hunger:DoDelta(-3)

    end



    if target.components.freezable then
        target.components.freezable:AddColdness(3)
    end
    if target.components.sleeper and target.components.sleeper:IsAsleep() then
        target.components.sleeper:WakeUp()
    end
    if target.components.burnable and target.components.burnable:IsBurning() then
        target.components.burnable:Extinguish()
    end
    if target.components.combat then
        target.components.combat:SuggestTarget(attacker)
        if target.sg and not target.sg:HasStateTag("frozen") and target.sg.sg.states.hit then
            target.sg:GoToState("hit")
        end
    end
end

local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("nightmaresword")
    inst.AnimState:SetBuild("xuezou")
    inst.AnimState:PlayAnimation("idle")
    inst.AnimState:SetMultColour(1, 1, 1, 1)
    
    inst:AddTag("sharp")
    inst:AddTag("shadow")
    
	inst:AddComponent("weapon")
 inst.components.weapon:SetRange(8, 10)
    inst.components.weapon:SetDamage(34)
 inst.components.weapon:SetProjectile("bishop_charge")



    inst:AddComponent("tool")
    inst.components.tool:SetAction(ACTIONS.CHOP, 15)
    inst.components.tool:SetAction(ACTIONS.MINE, 15)
 
   --inst:AddComponent("finiteuses")
    --inst.components.finiteuses:SetMaxUses(40)
    --inst.components.finiteuses:SetUses(40)
        inst.components.weapon:SetOnAttack(onattack)
    
    --inst.components.finiteuses:SetOnFinished( onfinished )

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/xuezou.xml"

    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
    







    return inst
end

return Prefab( "common/inventory/xuezou", fn, assets)